/* ----------------------------------------------------------------------------
 *  codingSpace18					
 * ----------------------------------------------------------------------------
 *  GUI - main class
 * ----------------------------------------------------------------------------
 *  prog: eddi.lecesne@zhdk.ch
 *  13.11.2010
 * ----------------------------------------------------------------------------
 */
//sliders
Slider sliderR = null;
Slider sliderG = null;
Slider sliderB = null;
//checkboxes
Checkbox checkboxA = null;
Checkbox checkboxB = null;
//double click
DoubleClick doubleClick = null;
boolean checkDoubleClick = false;

float mX, mY;  //for doubleclick

void setup()
{
  size(400, 400);
  //parameter: [x, y, width, height, start value (0..1)]
  sliderR = new Slider(20,50,50,20,.5);  
  sliderG = new Slider(150,50,100,80,.5);
  sliderB = new Slider(250,50,300,40,.5);
  //parameter: [x,y,diameter]
  checkboxA = new Checkbox(50, 300, 20);
  checkboxB = new Checkbox(150, 300, 50);
  
  doubleClick = new DoubleClick();
}

void draw()
{
  //background(sliderR.pos() * 255,sliderG.pos() * 255,sliderB.pos() * 255);
  background(240, 240, 240, 25);


  sliderR.draw();
  sliderG.draw();
  sliderB.draw();
  
  checkboxA.draw();
  checkboxB.draw();

  //check if doubleclicked
  if(checkDoubleClick)
    doubleClick.ping();  //returns an impulse-like ellipse at the last mouse position. stops when clicked anywhere

  sliderR.fillColor(sliderR.pos() * 255, 0, 0, 255);  //red and alpha
  sliderG.fillColor(0, sliderG.pos() * 255, 0, 255);  //green and alpha
  sliderB.fillColor(0, 0, sliderB.pos() * 255, 255);  //blue and alpha

  sliderR.mouseOver(mouseX, mouseY);
  sliderG.mouseOver(mouseX, mouseY);
  sliderB.mouseOver(mouseX, mouseY);

  //glow on mouse-over
  checkboxA.mouseOver(mouseX,mouseY);  
  checkboxB.mouseOver(mouseX,mouseY);
}

void mousePressed()
{
  sliderR.mousePos(mouseX,mouseY,true);
  sliderG.mousePos(mouseX,mouseY,true);
  sliderB.mousePos(mouseX,mouseY,true);
  
  //activate (fill) or deactivate( nofill) checkbox
  checkboxA.mousePos(mouseX,mouseY);
  checkboxB.mousePos(mouseX,mouseY);

  // send doubleclick request. returns a boolean
  checkDoubleClick = doubleClick.checkDoubleClick(millis());
  if(checkDoubleClick) {
    mX = mouseX;
    mY = mouseY;
  }
}

void mouseDragged()
{
  sliderR.mousePos(mouseX,mouseY,true);
  sliderG.mousePos(mouseX,mouseY,true);
  sliderB.mousePos(mouseX,mouseY,true);
}


