/* ----------------------------------------------------------------------------
 *  codingSpace18					
 * ----------------------------------------------------------------------------
 *  GUI - main class
 * ----------------------------------------------------------------------------
 *  prog: eddi.lecesne@zhdk.ch
 *  13.11.2010
 * ----------------------------------------------------------------------------
 */
class Checkbox
{
  PVector _p1;
  float     _r;
  float   _pos;
  boolean _activateFlag = false;
  int _time1;
  boolean _pressedOnce=false;

  Checkbox(int x,int y,int d)
  {   
    _p1 = new PVector(x, y);  //center of circle

    _r = d*0.5;
  }

  float pos()
  {
    return _pos;
  }
  //for main class if feedback is needed
  boolean isChecked(){
    return _activateFlag;
  }

  boolean isHit(int x,int y)
  {
    if(x > _p1.x-_r && x < _p1.x+_r && y > _p1.y-_r && y < _p1.y+_r) {
      return true;
    }
    else {
      return false;
    }
  }
  void draw()
  {
    //_time = System.currentTimeMillis();
    pushStyle();
    drawCheckbox();
    activate(_activateFlag);
    popStyle();
  }
  void drawCheckbox() {
    noFill();
    smooth();
    strokeWeight(2);   
    stroke(50,50,40,255);

    ellipse(_p1.x, _p1.y, _r*2, _r*2);
  }
  void mousePos(int x,int y)
  {
    if(isHit(x,y)) {
      _activateFlag = !_activateFlag;
    }
  }
  void mouseOver(int x, int  y) {
    if(isHit(x,y)) {
      noFill();
      strokeWeight(5);   
      stroke(50,50,40,90);
      ellipse(_p1.x, _p1.y, (_r*2)+2, (_r*2)+2);
    }
  }
  void activate(boolean a) {
    if(a) {
      strokeWeight(5);
      fill(50,50,40,100);   
      stroke(50,50,40,100);
      ellipse(_p1.x, _p1.y, (_r*2)+2, (_r*2)+2);

      text("active!", _p1.x,_p1.y+(_r*2));
    }
  }
}

